﻿using apifon_sdk_csharp.com.apifon.sdk.response;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace apifon_sdk_csharp.com.apifon.sdk.exception
{
    public class ApifonRestException : Exception
    {
        private readonly ApiErrorResponse resp;

        public ApifonRestException(string message) : base(message)
        {
            resp = null;
        }

        public ApifonRestException(string message, Exception ex) : base(message,ex)
        {
            resp = null;
        }

        public ApifonRestException(string message, Exception ex, ApiErrorResponse resp) : base(message,ex)
        {
            this.resp = resp;
        }

        public ApifonRestException(Exception ex) : base(ex.Message)
        {
            resp = null;
        }

        public ApifonRestException(Exception ex, ApiErrorResponse resp) : base(ex.Message)
        {
            this.resp = resp;
        }

        public ApifonRestException(ApiErrorResponse resp)
        {
            this.resp = resp;
        }

        public ApifonRestException(string message, ApiErrorResponse resp) : base(message)
        {
            this.resp = resp;
        }

        public ApiErrorResponse getResp()
        {
            return resp;
        }

        public override string ToString()
        {
            if (resp != null)
            {
                StringBuilder errorDetails = new StringBuilder();
                foreach (KeyValuePair<string, string> pair in resp.errorDetails)
                {
                    errorDetails.Append(pair.Key).Append(":").Append(pair.Value).Append(Environment.NewLine);
                }
                return "Status: " + resp.status.ToString() + Environment.NewLine
                        + "Title: " + resp.title + Environment.NewLine
                        + "Error details: " + errorDetails.ToString()
                        + "Error code: " + resp.errorReportCode;
            }
            else
            {
                return base.Message;
            }
        }

    }
}
