﻿using apifon_sdk_csharp.com.apifon.sdk.response;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace apifon_sdk_csharp.com.apifon.sdk.exception
{
    public class OAuthTokenException : OAuthException
    {
        private readonly OauthTokenErrorResponse oauthResponse;

        public OAuthTokenException(string message) : base(message)
        {
            oauthResponse = null;
        }

        public OAuthTokenException(string message, Exception ex) : base(message,ex)
        {
            oauthResponse = null;
        }

        public OAuthTokenException(Exception ex) : base(ex.Message)
        {
            oauthResponse = null;
        }

        public OAuthTokenException(string message, OauthTokenErrorResponse resp) : base(message)
        {
            this.oauthResponse = resp;
        }

        public OauthTokenErrorResponse getOAuthTokenErrorResponse()
        {
            return this.oauthResponse;
        }

        public override string ToString() 
        {
            if (oauthResponse != null)
            {
                int status = 400;
                if (oauthResponse.error.Equals("invalid_client"))
                {
                    status = 401;
                }

                return "Status: " + status + Environment.NewLine
                        + "Error: " + oauthResponse.error + Environment.NewLine
                        + "Error description : " + oauthResponse.error_description;
            }
            else
            {
                return base.Message;
            }
        }

    }
}
