using apifon_sdk_csharp.com.apifon.sdk.helpers;
using System.Collections.Generic;
using System.Runtime.Serialization;

namespace com.apifon.sdk.model
{

    [DataContract]
    public class IMChannel
    {
        private string id;
        private string senderId;
        private string text;
        private List<string> images;
        private List<IMAction> actions;
        private int? ttl;
        private string expiryText;
        private string deviceTarget;

        [DataMember(Name = "id")]
        public string Id
        { 
            get { return id; }
            set { id = value; } 
        }

        [DataMember(Name = "sender_id")]
        public string SenderId
        { 
            get { return senderId; }
            set { senderId = value; } 
        }

        [DataMember(Name = "text")]
        public string Text
        { 
            get { return text; }
            set { text = value; } 
        }

        [DataMember(Name = "images")]
        public List<string> Images
        { 
            get { return images; }
            set { images = value; } 
        }

        [DataMember(Name = "actions")]
        public List<IMAction> Actions
        { 
            get { return actions; }
            set { actions = value; } 
        }

        [DataMember(Name = "ttl")]
        public int? Ttl
        {
            get { return ttl; }
            set { ttl = value; }
        }

        [DataMember(Name = "expiry_text")]
        public string ExpiryText
        { 
            get { return expiryText; }
            set { expiryText = value; } 
        }

        [DataMember(Name = "device_target")]
        public string DeviceTarget
        { 
            get { return deviceTarget; }
            set { deviceTarget = value; }
        }

        public void AddImage(string image)
        {
            if(images == null)
            {
                images = new List<string>();
            }
            images.Add(image);
        }

        public void AddAction(IMAction action)
        {
            if(actions == null)
            {
                actions = new List<IMAction>();
            }
            actions.Add(action);
        }
    }
}
