﻿using apifon_sdk_csharp.com.apifon.sdk.helpers;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;

namespace apifon_sdk_csharp.com.apifon.sdk.model.request
{
    public class BounceRequestBuilder
    {
        private readonly string destination;
        private readonly string reason;
        private string description;


        private BounceRequestBuilder(string destination, string reason)
        {
            this.destination = destination;
            this.reason = reason;
        }

        public static BounceRequestBuilder getBounceRequestBuilder(string destination, string reason)
        {
            return new BounceRequestBuilder(destination, reason);
        }

        public BounceRequestBuilder withDescription(string description)
        {
            this.description = description;
            return this;
        }

        public BounceRequest build()
        {
            return new BounceRequest(this);
        }

        [DataContract]
        public class BounceRequest : IJsonSerializable
        {
            [DataMember(Name = "destination")]
            private readonly string destination;
            [DataMember(Name = "reason")]
            private readonly string reason;
            [DataMember(Name = "description")]
            private readonly string description;

            public BounceRequest(BounceRequestBuilder builder)
            {
                this.destination = builder.destination;
                this.reason = builder.reason;
                this.description = builder.description;
            }

            public string getDestination()
            {
                return destination;
            }

            public string getReason()
            {
                return reason;
            }

            public string getDescription()
            {
                return description;
            }

            public string getBody()
            {
                return JsonConvert.SerializeObject(this, Formatting.Indented,
                            new JsonSerializerSettings
                            {
                                NullValueHandling = NullValueHandling.Ignore
                            });
            }
        }
    }
}
