﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;

namespace com.apifon.sdk.model.request
{
    public class CampaignDefaultsBuilder
    {
        private string senderId;
        private string viberSenderId;
        private string senderName;
        private string from;
        private string replyTo;

        private CampaignDefaultsBuilder()
        {
        }

        private CampaignDefaultsBuilder(CampaignDefaults campaignDefaults)
        {
            if (campaignDefaults == null)
            {
                return;
            }
            this.from = campaignDefaults.getFrom();
            this.replyTo = campaignDefaults.getReplyTo();
            this.senderId = campaignDefaults.getSenderId();
            this.senderName = campaignDefaults.getSenderName();
            this.viberSenderId = campaignDefaults.getViberSenderId();
        }

        public static CampaignDefaultsBuilder getBuilderFromCampaignDefaults(CampaignDefaults defaults)
        {
            return new CampaignDefaultsBuilder(defaults);
        }

        public static CampaignDefaultsBuilder getCampaignDefaultsBuilder()
        {
            return new CampaignDefaultsBuilder();
        }

        public CampaignDefaultsBuilder setSenderId(string senderId)
        {
            this.senderId = senderId;
            return this;
        }

        public CampaignDefaultsBuilder setViberSenderId(string viberSenderId)
        {
            this.viberSenderId = viberSenderId;
            return this;
        }

        public CampaignDefaultsBuilder setSenderName(string senderName)
        {
            this.senderName = senderName;
            return this;
        }

        public CampaignDefaultsBuilder setFrom(string from)
        {
            this.from = from;
            return this;
        }

        public CampaignDefaultsBuilder setReplyTo(string replyTo)
        {
            this.replyTo = replyTo;
            return this;
        }

        public CampaignDefaults build()
        {
            return new CampaignDefaults(this);
        }

        [DataContract]
        public class CampaignDefaults
        {
            [DataMember(Name = "sender_id")]
            private readonly string senderId;
            [DataMember(Name = "viber_sender_id")]
            private readonly string viberSenderId;
            [DataMember(Name = "sender_name")]
            private readonly string senderName;
            [DataMember(Name = "from")]
            private readonly string from;
            [DataMember(Name = "reply_to")]
            private readonly string replyTo;

            public CampaignDefaults()
            {
           
            }

            public CampaignDefaults(CampaignDefaultsBuilder builder)
            {
                this.senderId = builder.senderId;
                this.senderName = builder.senderName;
                this.from = builder.from;
                this.viberSenderId = builder.viberSenderId;
                this.replyTo = builder.replyTo;
            }

            public string getSenderId()
            {
                return senderId;
            }

            public string getViberSenderId()
            {
                return viberSenderId;
            }

            public string getSenderName()
            {
                return senderName;
            }

            public string getFrom()
            {
                return from;
            }

            public string getReplyTo()
            {
                return replyTo;
            }
        }
    }
    
}
