﻿using apifon_sdk_csharp.com.apifon.sdk.helpers;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace apifon_sdk_csharp.com.apifon.sdk.model.request
{
    public class SubscriberSingleQuery : IFieldSerializable<SubscriberSingleQuery>, IHttpEtag
    {
        private readonly string lookupMD5;
        private readonly string listId;
        private readonly HashSet<string> fields;

        private SubscriberSingleQuery(string lookupMD5, string listId)
        {
            this.lookupMD5 = lookupMD5;
            this.listId = listId;
            this.fields = new HashSet<string>();
        }

        public static SubscriberSingleQuery getSubscriberLookup(string lookupMD5, string listId)
        {
            return new SubscriberSingleQuery(lookupMD5, listId);
        }

        public string getListId()
        {
            return listId;
        }

        public HashSet<string> getFields()
        {
            return this.fields;
        }

        public string getPathId()
        {
            return this.lookupMD5;
        }

        public SubscriberSingleQuery addVisibleFields(Collection<string> fields)
        {
            if (fields == null) { throw new System.ArgumentNullException("Parameter fields is null."); }
            this.getFields().UnionWith(fields);
            return this;
        }

        public SubscriberSingleQuery addVisibleField(string field)
        {
            if (field == null) { throw new System.ArgumentNullException("Parameter field is null."); }
            this.getFields().Add(field);
            return this;
        }

        public string getQueryParams()
        {
            string joinFields = "";
            if (getFields() != null && getFields().Any(x => true))
            {
                joinFields = string.Join(",", getFields());

                UriBuilder uriBuilder = new UriBuilder();
                uriBuilder.Query = "fields=" + joinFields;
                return uriBuilder.Query;
            }
            else
            {
                return "";
            }
        }

        public string getEtag()
        {
            throw new NotImplementedException();
        }
    }
}
