using System;
using System.Collections.Generic;
using System.Net;
using System.Web.Script.Serialization;

namespace com.apifon.sdk.resource
{
    abstract public class AbstractResource
    {
        [ScriptIgnore]
        private string endpoint;
        [ScriptIgnore]
        private string curEndpoint;
        [ScriptIgnore]
        private string curBody;
        [ScriptIgnore]
        private string curMethod;
        [ScriptIgnore]
        private readonly Dictionary<string, string> curHeaders;

        public AbstractResource(string endpoint)
        {
            this.endpoint = endpoint;
            this.curHeaders = new Dictionary<string, string>();
        }

        public string GetEndpoint()
        {
            return endpoint;
        }

        public void SetEndpoint(string endpoint)
        {
            this.endpoint = endpoint;
        }

        public string GetCurEndpoint()
        {
            return curEndpoint;
        }

        public void SetCurEndpoint(string curEndpoint)
        {
            this.curEndpoint = curEndpoint;
        }
        
        public string GetCurBody()
        {
            return curBody;
        }
        
        public void SetCurBody(string curBody)
        {
            this.curBody = curBody;
        }
        
        public string GetCurMethod()
        {
            return curMethod;
        }
        
        public void SetCurMethod(string curMethod)
        {
            this.curMethod = curMethod;
        }

        public Dictionary<string, string> getCurHeaders()
        {
            return curHeaders;
        }

        public void addEtagHeader(string etag)
        {
            if (etag == null)
            {
                return;
            }
            this.curHeaders.Add("If-Match", etag);
        }

        public string Dispatch()
        {
            return Mookee.Dispatch(this);
        }

        public WebResponse DispatchToResponse()
        {
            return Mookee.DispatchToResponse(this);
        }

        public string Create()
        {
            throw new NotImplementedException();
        }

        public string Read()
        {
            throw new NotImplementedException();
        }

        public string Update()
        {
            throw new NotImplementedException();
        }

        public string Delete()
        {
            throw new NotImplementedException();
        }

        public void addHeaders(Dictionary<string, string> headers)
        {
            headers = curHeaders;
        }

        public bool isSuccessful(HttpWebResponse resp)
        {
            if (resp.StatusCode == HttpStatusCode.NotModified)
            {
                Console.WriteLine("Status: 304 " + Environment.NewLine
                    + "Title: Not modified. The request was completed but the resource was not modified.");
            }
            return true;
        }

        public string getResponseBody(WebResponse response)
        {
            return Mookee.getResponseBody(response);
        }

    }
}
