﻿using apifon_sdk_csharp.com.apifon.sdk.helpers;
using apifon_sdk_csharp.com.apifon.sdk.model;
using apifon_sdk_csharp.com.apifon.sdk.model.request;
using apifon_sdk_csharp.com.apifon.sdk.response;
using apifon_sdk_csharp.com.apifon.sdk.serializer;
using com.apifon.sdk.resource;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;
using static apifon_sdk_csharp.com.apifon.sdk.model.request.BounceRequestBuilder;

namespace apifon_sdk_csharp.com.apifon.sdk.resource
{
    public class BounceListResource : AbstractResource, UriLocator<BounceResponse>
    {
        public BounceListResource() : base("/services/api/v1/bounce/subscriber")
        {

        }

        public Uri addBounceSubscriber(BounceRequest request)
        {
            this.SetCurMethod("POST");
            this.SetCurEndpoint(this.GetEndpoint() + "/block");
            this.SetCurBody(request.getBody());

            WebResponse response = this.DispatchToResponse();
            return new Uri(response.Headers["Location"].ToString());
        }

        public CollectionEntityResponse<BounceResponse> getBounceSubscribers(PaginatedRequest request)
        {
            this.SetCurMethod("GET");
            this.SetCurEndpoint(this.GetEndpoint() + "/" + request.toQueryParamRequest());
            this.SetCurBody("");

            WebResponse response = this.DispatchToResponse();
            string responseContent = this.getResponseBody(response);
            
            return JsonConvert.DeserializeObject<CollectionEntityResponse<BounceResponse>>(responseContent);
        }

        public CollectionEntityResponse<BounceResponse> getBounceSubscribers(string paginationUrl)
        {
            return getListByResouceUri(new Uri(paginationUrl));
        }

        public BounceResponse getBounceSubscriber(BounceSingleQuery request)
        {
            this.SetCurMethod("GET");
            this.SetCurEndpoint(this.GetEndpoint() + "/" + request.getPathId() + request.getQueryParams());
            this.SetCurBody("");

            WebResponse response = this.DispatchToResponse();
            string responseContent = this.getResponseBody(response);
            
            return JsonConvert.DeserializeObject<BounceResponse>(responseContent);

        }

        public BounceResponse getByResourceUri(Uri resourceUri)
        {
            string[] pathParams = resourceUri.Segments;
            string destination = pathParams[pathParams.Length - 1];
            return getBounceSubscriber(BounceSingleQuery.getBounceLookup(destination));
        }

        public bool removeBounceSubscriber(string destination)
        {
            if (string.IsNullOrEmpty(destination))
            {
                throw new System.ArgumentNullException("Parameter destination is null.");
            }
            this.SetCurMethod("DELETE");
            this.SetCurEndpoint(this.GetEndpoint() + "/unblock/" + destination);
            this.SetCurBody("");

            HttpWebResponse response = (HttpWebResponse)this.DispatchToResponse();
            return this.isSuccessful(response);
        }

        public CollectionEntityResponse<BounceResponse> getListByResouceUri(Uri resourceUri)
        {
            this.SetCurMethod("GET");
            this.SetCurEndpoint(resourceUri.ToString());
            this.SetCurBody("");

            WebResponse response = this.DispatchToResponse();
            string responseContent = this.getResponseBody(response);
            
            return JsonConvert.DeserializeObject<CollectionEntityResponse<BounceResponse>>(responseContent);
        }
    }
}
