﻿using apifon_sdk_csharp.com.apifon.sdk.model.request;
using com.apifon.sdk.resource;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;

namespace apifon_sdk_csharp.com.apifon.sdk.resource
{
    public class GdprFieldResource : AbstractResource
    {
        public GdprFieldResource() : base("/services/api/v1/list/{list_id}/gdpr")
        {

        }

        public void replacePlaceholderAndSetUrl(string endpoint, string listId)
        {
            base.SetCurEndpoint(endpoint.Replace("{list_id}", listId));
        }

        public Uri addGdprField(GdprFieldRequestBuilder.GdprFieldRequest request)
        {
            this.SetCurMethod("POST");
            this.replacePlaceholderAndSetUrl(this.GetEndpoint() + "/", request.getListId());
            this.SetCurBody(request.getBody());

            WebResponse response = this.DispatchToResponse();
            return new Uri(response.Headers["Location"].ToString());
        }

        public Uri updateGdprField(GdprFieldRequestBuilder.GdprFieldRequest request)
        {
            this.SetCurMethod("PUT");
            this.replacePlaceholderAndSetUrl(this.GetEndpoint() + "/" + request.getField(), request.getListId());
            this.SetCurBody(request.getBody());

            WebResponse response = this.DispatchToResponse();
            return new Uri(response.Headers["Location"].ToString());
        }
    }
}
