﻿using apifon_sdk_csharp.com.apifon.sdk.model.request;
using com.apifon.sdk.resource;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;

namespace apifon_sdk_csharp.com.apifon.sdk.resource
{
    public class SubscriberFieldResource : AbstractResource
    {
        public SubscriberFieldResource() : base("/services/api/v1/list/{list_id}/field")
        {
           
        }

        public void replacePlaceholderAndSetUrl(string endpoint, string listId)
        {
            base.SetCurEndpoint(endpoint.Replace("{list_id}", listId));
        }

        public Uri addSubscriberField(SubscriberFieldRequestBuilder.SubscriberFieldRequest request)
        {
            this.SetCurMethod("POST");
            this.replacePlaceholderAndSetUrl(this.GetEndpoint() + "/", request.getListId());
            this.SetCurBody(request.getBody());

            WebResponse response = this.DispatchToResponse();
            return new Uri(response.Headers["Location"].ToString());
        }

        public Uri updateSubscriberField(SubscriberFieldRequestBuilder.SubscriberFieldRequest request)
        {
            this.SetCurMethod("PUT");
            this.replacePlaceholderAndSetUrl(this.GetEndpoint() + "/" + request.getField(), request.getListId());
            this.SetCurBody(request.getBody());

            WebResponse response = this.DispatchToResponse();
            return new Uri(response.Headers["Location"].ToString());
        }

        public bool removeSubscriberField(string listId, string field)
        {
            this.SetCurMethod("DELETE");
            this.replacePlaceholderAndSetUrl(this.GetEndpoint() + "/" + field, listId);
            this.SetCurBody("");

            HttpWebResponse response = (HttpWebResponse)this.DispatchToResponse();
            return this.isSuccessful(response);
        }
    }
}
