﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Cryptography;
using System.Text;
using System.Threading.Tasks;

namespace apifon_sdk_csharp.com.apifon.sdk.resource.helpers
{
    public class S256PKCEChallenge : ICloneable
    {
        private readonly string codeVerifier;
        private readonly string codeChallenge;

        public S256PKCEChallenge(string codeVerifier)
        {
            try
            {
                byte[] codeVerifierBytes = System.Text.Encoding.ASCII.GetBytes(codeVerifier);

                HashAlgorithm md = SHA256.Create();
                md.TransformFinalBlock(codeVerifierBytes, 0, codeVerifierBytes.Length);

                this.codeVerifier = codeVerifier;
                this.codeChallenge = System.Convert.ToBase64String(md.ComputeHash(codeVerifierBytes)).Split('=')[0];
            }
            catch (Exception ex)
            {
                throw new InvalidOperationException(ex.Message);
            }
        }

        public static S256PKCEChallenge getRandomS256PKCEChallenge()
        {
            byte[] code = new byte[32];
            new Random().NextBytes(code);

            string randomCodeVerifier = System.Convert.ToBase64String(code).Split('=')[0];
            return new S256PKCEChallenge(randomCodeVerifier);
        }

        public string getCodeVerifier()
        {
            return codeVerifier;
        }

        public string getCodeChallenge()
        {
            return codeChallenge;
        }

        public object Clone()
        {
            base.MemberwiseClone();
            S256PKCEChallenge clone = new S256PKCEChallenge(this.codeVerifier);
            return clone;
        }
    }
}
