﻿using apifon_sdk_csharp.com.apifon.sdk.helpers;
using apifon_sdk_csharp.com.apifon.sdk.model;
using apifon_sdk_csharp.com.apifon.sdk.serializer;
using com.apifon.sdk.helpers;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;
using static com.apifon.sdk.model.request.CampaignDefaultsBuilder;
using static com.apifon.sdk.model.request.GdprPropertiesBuilder;

namespace apifon_sdk_csharp.com.apifon.sdk.response
{
    [DataContract]
    public class ListResponse : SingleResponse
    {
        [DataMember(Name = "id")]
        private string id;
        [DataMember(Name = "account_id")]
        private long accountId;
        [DataMember(Name = "type")]
        private string type;
        [DataMember(Name = "title")]
        private string title;
        [DataMember(Name = "status")]
        private string status;
        [DataMember(Name = "description")]
        private string description;
        [JsonConverter(typeof(DateAdapter))]
        [DataMember(Name = "date_created")]
        private DateTime dateCreated;
        [JsonConverter(typeof(DateAdapter))]
        [DataMember(Name = "date_updated")]
        private DateTime dateUpdated;
        [DataMember(Name = "campaign_defaults")]
        private CampaignDefaults campaignDefaults;
        [DataMember(Name = "total_subscribers")]
        private int totalSubscribers;
        [DataMember(Name = "active_subscribers")]
        private int activeSubscribers;
        [DataMember(Name = "active_email_subscribers")]
        private int activeEmailSubscribers;
        [DataMember(Name = "form_id")]
        private string formId;
        [DataMember(Name = "subscriber_fields")]
        private List<SubscriberFieldResponse> subscriberFields;
        [DataMember(Name = "gdpr_fields")]
        private List<GdprFieldResponse> gdprFields;
        [DataMember(Name = "brand_name")]
        private string brandName;
        [DataMember(Name = "company_name")]
        private string companyName;
        [DataMember(Name = "gdpr_properties")]
        private GdprProperties gdprProperties;
        [DataMember(Name = "form_urls")]
        private Dictionary<FormCategory, string> formUrls;
        [DataMember(Name = "prefix")]
        private string prefix;
        [DataMember(Name = "groups")]
        private List<GroupResponse> groups;

        public List<SubscriberFieldResponse> getSubscriberFields()
        {
            return subscriberFields;
        }

        public List<GdprFieldResponse> getGdprFields()
        {
            return gdprFields;
        }


        public string getId()
        {
            return id;
        }

        
        public long getAccountId()
        {
            return accountId;
        }

        
        public string getType()
        {
            return type;
        }

        public string getTitle()
        {
            return title;
        }

        public string getStatus()
        {
            return status;
        }

        public string getDescription()
        {
            return description;
        }

        public DateTime getDateCreated()
        {
            return dateCreated;
        }

        public DateTime getDateUpdated()
        {
            return dateUpdated;
        }

        public CampaignDefaults getCampaignDefaults()
        {
            return campaignDefaults;
        }


        public int getTotalSubscribers()
        {
            return totalSubscribers;
        }

        public int getActiveSubscribers()
        {
            return activeSubscribers;
        }

        public int getActiveEmailSubscribers()
        {
            return activeEmailSubscribers;
        }

        public string getFormId()
        {
            return formId;
        }

        public string getBrandName()
        {
            return brandName;
        }

        public string getCompanyName()
        {
            return companyName;
        }

        public GdprProperties getGdprProperties()
        {
            return gdprProperties;
        }

        public Dictionary<FormCategory, string> getFormUrls()
        {
            return formUrls;
        }

        public string getPrefix()
        {
            return prefix;
        }
        public List<GroupResponse> getGroups()
        {
            return groups;
        }

    }
}
