﻿using apifon_sdk_csharp.com.apifon.sdk.helpers;
using apifon_sdk_csharp.com.apifon.sdk.model;
using apifon_sdk_csharp.com.apifon.sdk.serializer;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;

namespace apifon_sdk_csharp.com.apifon.sdk.response
{
    [DataContract]
    public class SubscriberResponse : SingleResponse
    {
        [DataMember(Name = "id")]
        private String id;
        [DataMember(Name = "account_id")]
        private long accountId;
        [DataMember(Name = "destination")]
        private String destination;
        [DataMember(Name = "destination_id")]
        private String destinationId;
        [DataMember(Name = "email_id")]
        private String emailId;
        [DataMember(Name = "email")]
        private String email;
        [JsonConverter(typeof(DateAdapter))]
        [DataMember(Name = "date_created")]
        private DateTime dateCreated;
        [JsonConverter(typeof(DateAdapter))]
        [DataMember(Name = "date_updated")]
        private DateTime dateUpdated;
        [DataMember(Name = "list_id")]
        private String listId;
        [DataMember(Name = "status")]
        private string status;
        [DataMember(Name = "email_status")]
        private string emailStatus;
        [DataMember(Name = "gdpr_fields")] 
        private Dictionary<String, SubscriberGdprField> gdprFields;
        [DataMember(Name = "subscriber_fields")]
        private Dictionary<String, Object> subscriberFields;
        [DataMember(Name = "groupOptions")]
        private List<String> groupOptions;

        public string getId()
        {
            return id;
        }

        public long getAccountId()
        {
            return accountId;
        }

        public string getDestination()
        {
            return destination;
        }

        public string getDestinationId()
        {
            return destinationId;
        }

        public string getEmailId()
        {
            return emailId;
        }

        public string getEmail()
        {
            return email;
        }

        public DateTime getDateCreated()
        {
            return dateCreated;
        }

        public DateTime getDateUpdated()
        {
            return dateUpdated;
        }

        public String getListId()
        {
            return listId;
        }

        public string getStatus()
        {
            return status;
        }

        public string getEmailStatus()
        {
            return emailStatus;
        }

        public Dictionary<string, SubscriberGdprField> getGdprFields()
        {
            return gdprFields;
        }

        public Dictionary<string, Object> getSubscriberFields()
        {
            return subscriberFields;
        }
        public List<String> getGroupOptions()
        {
            return groupOptions;
        }

        public void setId(String id)
        {
            this.id = id;
        }

        public void setAccountId(long accountId)
        {
            this.accountId = accountId;
        }

        public void setDestination(String destination)
        {
            this.destination = destination;
        }

        public void setDestinationId(String destinationId)
        {
            this.destinationId = destinationId;
        }

        public void setEmailId(String emailId)
        {
            this.emailId = emailId;
        }

        public void setEmail(String email)
        {
            this.email = email;
        }

        public void setDateCreated(DateTime dateCreated)
        {
            this.dateCreated = dateCreated;
        }

        public void setDateUpdated(DateTime dateUpdated)
        {
            this.dateUpdated = dateUpdated;
        }

        public void setListId(string listId)
        {
            this.listId = listId;
        }

        public void setStatus(string status)
        {
            this.status = status;
        }

        public void setEmailStatus(string emailStatus)
        {
            this.emailStatus = emailStatus;
        }

        public void setGdprFields(Dictionary<string, SubscriberGdprField> gdprFields)
        {
            this.gdprFields = gdprFields;
        }

        public void setSubscriberFields(Dictionary<string, Object> subscriberFields)
        {
            this.subscriberFields = subscriberFields;
        }


    }
}
